import groovy.transform.*

class Friend {
  def listen() {
    println "I'm $name, listening..."
  }
}

@Mixin(Friend)
class Person {
  String name
}

class Animal {}
  
class SquirrelChaser {
  def chase() { println 'run like mad' }
}  
  
@Mixin([Friend, SquirrelChaser])
class Dog extends Animal {
  String name
}

def joe = new Person(name: 'Joe')
joe.listen()


def buddy = new Dog(name: "Buddy")
buddy.listen()
buddy.chase()